package service

import (
	discoveryM "git.loafle.net/overflow/overflow_commons_go/modules/discovery/model"
	oopmCentral "git.loafle.net/overflow/overflow_probes/manager/central"
	oopmContainer "git.loafle.net/overflow/overflow_probes/manager/container"
)

type DiscoveryService struct {
	CentralManager   oopmCentral.CentralManager     `annotation:"@inject{name:probeClient}"`
	ContainerManager oopmContainer.ContainerManager `annotation:"@inject{name:containerManager}"`
}

func (ds *DiscoveryService) DiscoverZone(dz *discoveryM.DiscoveryZone) error {
	return ds.ContainerManager.GetClient("").Send("DiscoveryService.DiscoverZone", dz)
}

func (ds *DiscoveryService) DiscoverHost(zone *discoveryM.Zone, dh *discoveryM.DiscoveryHost) error {
	return ds.ContainerManager.GetClient("").Send("DiscoveryService.DiscoverHost", zone, dh)
}

func (ds *DiscoveryService) DiscoverPort(host *discoveryM.Host, dp *discoveryM.DiscoveryPort) error {
	return ds.ContainerManager.GetClient("").Send("DiscoveryService.DiscoverPort", host, dp)
}

func (ds *DiscoveryService) DiscoverService(port *discoveryM.Port, dService *discoveryM.DiscoveryService) error {
	return ds.ContainerManager.GetClient("").Send("DiscoveryService.DiscoverZone", port, dService)
}

// use by discovery
func (ds *DiscoveryService) DiscoveredZone(zone *discoveryM.Zone) error {
	return ds.CentralManager.GetClient("").Send("DiscoveryService.DiscoveredZone", zone)
}

func (ds *DiscoveryService) DiscoveredHost(host *discoveryM.Host) error {
	return ds.CentralManager.GetClient("").Send("DiscoveryService.DiscoveredHost", host)
}

func (ds *DiscoveryService) DiscoveredPort(port *discoveryM.Port) error {
	return ds.CentralManager.GetClient("").Send("DiscoveryService.DiscoveredPort", port)
}

func (ds *DiscoveryService) DiscoveredService(service *discoveryM.Service) error {
	return ds.CentralManager.GetClient("").Send("DiscoveryService.DiscoveredService", service)
}
